using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using System.Diagnostics;
using System.Text;
using Syncfusion.ComponentModel;

namespace SampleApplication
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.ListBox listBox2;
		private System.Windows.Forms.ListBox listBox1;
		private ArrayList formulaTags;
		
		//needed to conditionally display new stacks
		private int oldRedoCount;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid2;
		private System.Windows.Forms.RichTextBox richTextBox1;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.TextBox textBox1;
		private int oldUndoCount;
		
		/*
		private RichTextBox rtb = new RichTextBox();

		protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style) 
		{
			if (!(CurrentCell.HasCurrentCellAt(rowIndex, colIndex) && CurrentCell.IsModified && HasControlValue))
			{
				string rtf = style.Text;
				if (!RichTextPaint.IsValidRtf(rtf))
				{
					rtb.SelectAll();
					rtb.SelectedText = rtf;
					style.Text = rtb.Rtf;
				}
			}
			base.OnDraw(g, clientRectangle, rowIndex, colIndex, style);
		}
		*/

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.gridDataBoundGrid2 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.button6 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid2)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 8);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(520, 144);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.CellDrawn += new Syncfusion.Windows.Forms.Grid.GridDrawCellEventHandler(this.gridDataBoundGrid1_CellDrawn);
			this.gridDataBoundGrid1.ResizingColumns += new Syncfusion.Windows.Forms.Grid.GridResizingColumnsEventHandler(this.gridDataBoundGrid1_ResizingColumns);
			this.gridDataBoundGrid1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.gridDataBoundGrid1_MouseUp);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(696, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(48, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Undo";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(640, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(48, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Redo";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// listBox2
			// 
			this.listBox2.Location = new System.Drawing.Point(648, 80);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(104, 69);
			this.listBox2.TabIndex = 4;
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(552, 80);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(88, 69);
			this.listBox1.TabIndex = 3;
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(552, 48);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(88, 24);
			this.button3.TabIndex = 5;
			this.button3.Text = "Show Column";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(648, 48);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(104, 24);
			this.button4.TabIndex = 6;
			this.button4.Text = "Hide Columns";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(536, 8);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(96, 24);
			this.button5.TabIndex = 7;
			this.button5.Text = "Create DataSet";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// gridDataBoundGrid2
			// 
			this.gridDataBoundGrid2.AllowDragSelectedCols = true;
			this.gridDataBoundGrid2.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid2.Location = new System.Drawing.Point(8, 176);
			this.gridDataBoundGrid2.Name = "gridDataBoundGrid2";
			this.gridDataBoundGrid2.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid2.Size = new System.Drawing.Size(520, 224);
			this.gridDataBoundGrid2.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid2.TabIndex = 8;
			this.gridDataBoundGrid2.Text = "gridDataBoundGrid2";
			// 
			// richTextBox1
			// 
			this.richTextBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.richTextBox1.Location = new System.Drawing.Point(552, 224);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(192, 72);
			this.richTextBox1.TabIndex = 9;
			this.richTextBox1.Text = "";
			// 
			// button6
			// 
			this.button6.Location = new System.Drawing.Point(608, 360);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(104, 24);
			this.button6.TabIndex = 10;
			this.button6.Text = "button6";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(552, 160);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(192, 20);
			this.textBox1.TabIndex = 11;
			this.textBox1.Text = "textBox1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(752, 437);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.button6);
			this.Controls.Add(this.richTextBox1);
			this.Controls.Add(this.gridDataBoundGrid2);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.listBox2);
			this.Controls.Add(this.listBox1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			this.gridDataBoundGrid1.Model.CellModels.Add("MyRichText", new MyGridRichTextBoxCellModel(this.gridDataBoundGrid1.Model));
			//this.gridDataBoundGrid1.Properties.Buttons3D = false;
			//this.gridDataBoundGrid1.Properties.MarkRowHeader=true;

			for(int i = 0; i < nCols; i++)
			{
				//DataColumn dcol;
				//dcol = new DataColumn();
				if (i/2==0)
					dt.Columns.Add(new DataColumn(string.Format("Col Great Boss Enjoy {0}", i)));
				else
					dt.Columns.Add(new DataColumn(string.Format("Col Enjoy {0}", i)));
				//dt.Columns.Add(dcol);
			}

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				
				//for(int j = 0; j < nCols; j++)
				//dr[j] = string.Format("row{0} col{1}", i, j);

					/*
					for(int j = 0; j < nCols; j++)
					{
						if(j == 1)
						{
							dr[j] =  @"{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fnil\fcharset0 Microsoft Sans Serif;}}"
								+@"\viewkind4\uc1\pard\f0\fs17 "
								+ string.Format("row{0} col{1}", i, j)
								+@"\par }" ;
						}
						else
						{
							dr[j] =  string.Format("row{0} col{1}", i, j);
						}
					}*/
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = null;
			this.gridDataBoundGrid1.DataSource = dt;

			//Get the rows numbers
			this.gridDataBoundGrid1.Model.Options.NumberedRowHeaders = true;
			this.gridDataBoundGrid1.BaseStylesMap["Row Header"].StyleInfo.CellType = "Header";

			this.gridDataBoundGrid1.Binder.InternalColumns[1].StyleInfo.CellType = "MyRichText";
		//	this.gridDataBoundGrid1.Binder.InternalColumns[2].StyleInfo.CellType = "FormulaCell";

			//subscribe to the event
			//this.gridDataBoundGrid1.Model.PasteCellText += new GridPasteCellTextEventHandler(grid_PasteCellText);
			this.gridDataBoundGrid1.Model.ClipboardPaste += new GridCutPasteEventHandler(grid_ClipBoardPaste);

			this.gridDataBoundGrid1.AllowResizeToFit = false;
			this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Row(0), GridResizeToFitOptions.IncludeHeaders);

			//option 2  maintain formulaTags for the cells
			formulaTags = new ArrayList();

			/*
			//option 2  maintain formulaTags for the cells
			formulaTags = new ArrayList();

			for(int i = 0; i <= dt.Rows.Count + 1; ++i)
			{
				formulaTags.Add(null);
			}
			*/

			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(GridSaveCellInfo);

			oldRedoCount = 0;
			oldUndoCount = 0;

			this.gridDataBoundGrid1.Model.CommandStack.Enabled = true;
		}

		private void GridSaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex <= dt.Rows.Count)
			{
				formulaTags[e.RowIndex - 1] = e.Style.FormulaTag;
				e.Handled = true;
			}
		}
		private void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex <= dt.Rows.Count)
			{
				formulaTags.Add(null);
				e.Style.CellType = "FormulaCell";
				//e.Style.Text = string.Format("=({0}{1} + {2}{1}) / 2", GridRangeInfo.GetAlphaLabel(1), GridRangeInfo.GetNumericLabel(e.RowIndex),GridRangeInfo.GetAlphaLabel(2)); 
				e.Style.FormulaTag = (GridFormulaTag) this.formulaTags[e.RowIndex - 1];
				e.Handled = true;
			}
		}

//		//the handler
//		private void grid_PasteCellText(object sender, GridPasteCellTextEventArgs e)
//		{
//			if(e.RowIndex >= this.gridDataBoundGrid1.Model.RowCount)
//			{
//				e.Cancel = true;
//			}
//		}

		private void grid_ClipBoardPaste(object sender, GridCutPasteEventArgs e)
		{
			DataObject data = (DataObject) Clipboard.GetDataObject();
			if(data.GetDataPresent(DataFormats.Text))
			{
				//get the size of teh data object in rows
				string s = (string)data.GetData(DataFormats.Text);
				string[] rows = s.Split(new char[]{'\n'});
				int numRows = rows.GetLength(0);
				if(numRows > 0 && rows[numRows - 1].Length == 0)
					numRows--; //remove extra empty row if present
//				int numCols = 0;
//				if(numRows > 0)
//				{
//					string[] cols = rows[0].Split(new char[]{'\t'});
//					numCols = cols.GetLength(0);
//				}
				
				//add rows if needed...
				if(this.gridDataBoundGrid1.Binder.IsAddNew && numRows <= 1)
					return;

				GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
				this.gridDataBoundGrid1.BeginUpdate();
				this.gridDataBoundGrid1.Binder.SuspendBinding();
				int row = cc.RowIndex;
				int oldRowCount = this.gridDataBoundGrid1.Model.RowCount;
				int extraRowIfStartAtAddNewRow = this.gridDataBoundGrid1.Binder.IsAddNew ? 1 : 0;
				while(row + numRows + extraRowIfStartAtAddNewRow > oldRowCount)
				{
					DataRow dr = dt.NewRow();
					dt.Rows.Add(dr);
					row--;
				}
				this.gridDataBoundGrid1.Binder.ResumeBinding();
				this.gridDataBoundGrid1.EndUpdate();
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Model.CommandStack.Undo();
			ShowStacks();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Model.CommandStack.Redo();
			ShowStacks();
		}

		private void ShowStacks()
		{
			ShowRedoStack();
			ShowUndoStack();
		}

		private void ShowUndoStack()
		{
			int numUndos = this.gridDataBoundGrid1.Model.CommandStack.UndoStack.Count;
			if(numUndos != this.oldUndoCount || this.gridDataBoundGrid1.Model.CommandStack.InTransaction)
			{
				this.listBox1.Items.Clear();
				this.listBox1.Items.Add(string.Format("{0} Undo items", numUndos));
	
				if(numUndos > 0 || this.gridDataBoundGrid1.Model.CommandStack.IsRecording)
					DisplayCommandsInStack(this.gridDataBoundGrid1.Model.CommandStack.UndoStack.ToArray(), "", listBox1, true);
				this.oldUndoCount = numUndos;
			}

		}

		private void ShowRedoStack()
		{
			int numRedos = this.gridDataBoundGrid1.Model.CommandStack.RedoStack.Count;
			if(numRedos != this.oldRedoCount || this.gridDataBoundGrid1.Model.CommandStack.InTransaction)
			{
				this.listBox2.Items.Clear();
				this.listBox2.Items.Add(string.Format("{0} Redo items", numRedos));
				if(numRedos > 0 || this.gridDataBoundGrid1.Model.CommandStack.IsRecording)
					DisplayCommandsInStack(this.gridDataBoundGrid1.Model.CommandStack.RedoStack.ToArray(), "", listBox2, false);
				this.oldRedoCount = numRedos;
			}
		}

		private void DisplayCommandsInStack(object[] items, string indent, ListBox _listbox, bool includeCurrentCommand)
		{
			string s;
			SyncfusionCommand c;
			GridTransactionCommand tc;
			int cutOff;

			//handle the case where we are recording a transaction
			if (includeCurrentCommand && this.gridDataBoundGrid1.Model.CommandStack.InTransaction)
			{
				try
				{
					tc = this.gridDataBoundGrid1.Model.CommandStack.CurrentTransactionCommand;
					DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, false);
				}
				catch{}
			}

			foreach(object o in items)
			{
				try
				{
					c = (SyncfusionCommand) o;
					if(c != null && c.Description != null)
						s = c.Description;
					else
						s = o.ToString();
					cutOff =  1 + Math.Max(s.LastIndexOf("+"), s.LastIndexOf("."));
					_listbox.Items.Add(indent + s.Substring(cutOff));
				}
				catch{}

				//check if is a transaction command
				try
				{
					tc = o as GridTransactionCommand;
					if(tc != null)
					{
						DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, false);
					}
				}
				catch{}

			}

			
		}

		private void model_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
		{
			if(e.Range.Width > 1 || e.Range.Height > 1)
			{
				GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
				this.gridDataBoundGrid1.RefreshRange(cc.RangeInfo, true);
			}
		}
		private void gridDataBoundGrid1_CellDrawn(object sender, GridDrawCellEventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			if(e.ColIndex == cc.ColIndex && e.RowIndex == cc.RowIndex
				&& this.gridDataBoundGrid1.Selections.Ranges.AnyRangeContains(cc.RangeInfo))
			{
				using(SolidBrush br = new SolidBrush(this.gridDataBoundGrid1.AlphaBlendSelectionColor))
				{
					e.Graphics.FillRectangle(br, e.Bounds);
				}
			}
		}

		private bool resized = false;
		private void gridDataBoundGrid1_ResizingColumns(object sender, GridResizingColumnsEventArgs e)
		{
			if(e.Reason == GridResizeCellsReason.MouseDown)
				this.resized = true;
			
			if(e.Reason == GridResizeCellsReason.DoubleClick)
			{
				this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(e.Columns, GridResizeToFitOptions.IncludeHeaders);
				e.Cancel = true;
			}
		}

		private void gridDataBoundGrid1_MouseUp(object sender, MouseEventArgs e)
		{
			if(this.resized)
			{
				this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());
				this.resized = false;
			}
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Model.HideCols[1] = true;
			this.gridDataBoundGrid1.Model.HideCols[2] = true;
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Model.HideCols[1] = false;
			this.gridDataBoundGrid1.Model.HideCols[2] = false;
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			string tableName = "MyGrid";
			string dsName = "MyDataSet";
			DataSet ds = GetDataSetFromGrid(this.gridDataBoundGrid1, tableName, dsName);
			
			this.gridDataBoundGrid2.DataSource = null;
			this.gridDataBoundGrid2.DataSource = ds.Tables[tableName];
		}

		private DataSet GetDataSetFromGrid(GridDataBoundGrid grid, string tableName, string dataSetName)
		{
			DataTable dt = new DataTable(tableName);

			for(int i = 0; i < grid.Model.ColCount; ++i)
			{
				string colName = grid[0, i + 1].Text;
				if(colName.Length == 0)
					colName = GridRangeInfo.GetAlphaLabel(i + 1);
				Type t = grid.Model.ColStyles[i + 1].CellValueType;

				if(t == null)
					t = typeof(string);
				DataColumn dc = new DataColumn(colName, t);
				dt.Columns.Add(dc);
			}

			for(int i = 0; i < grid.Model.RowCount; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < grid.Model.ColCount; ++j)
				{
					GridStyleInfo style = grid[i+1, j+1];
					if (style.Text.Length > 0 && style.Text[0].ToString() == "=")
					{
						MessageBox.Show(style.Text.ToString());
						MessageBox.Show(grid[i+1, j+1].FormattedText.ToString());
					}			
					dr[j] = grid[i+1, j+1].CellValue;
				}
				dt.Rows.Add(dr);
			}
			dt.AcceptChanges();
			DataSet ds = new DataSet(dataSetName);
			ds.Tables.Add(dt);

			return ds;
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			//richTextBox1.Rtf
			MessageBox.Show(this.gridDataBoundGrid1[1, 2].Text.ToString());
			textBox1.Text = this.gridDataBoundGrid1[1, 2].Text.ToString();
			richTextBox1.SelectedRtf = textBox1.Text;
			MessageBox.Show(richTextBox1.Rtf);
			MessageBox.Show(richTextBox1.Text);
		}

	}
}
